﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using rfid;

namespace UniqueCS
{
  public partial class Form1 : Form
  {
    int TTYP = GIS_LF_API.TTYP_HITAG_S;

    static string MakeStringFromArray(sbyte[] Arr,int StringNummer)
    {
      string strLine;
      strLine = "";

      int i = 0;
      for (int aktStringNummer = 0; aktStringNummer <= StringNummer; aktStringNummer++)
      {
        strLine = "";
        for (; (i < Arr.Length); i++)
        {
          if (Arr[i] == 0)
          {
            break;
          }
          strLine += (char)Arr[i];
        }
        i++;
        if (strLine.Length == 0)
          break;
      }
      return strLine;
    }

    static sbyte[] MakeArrayFromString(string Name)
    {
      sbyte[] arr = new sbyte[Name.Length];
      for (int i = 0; i < Name.Length; i++)
        arr[i] = (sbyte)Name[i];
      return arr;
    }

    static string MakeStringFromByteArray(Byte[] Arr)
    {
      string strLine;
      strLine = "";

      int i = 0;
      for (; (i < Arr.Length); i++)
      {
        if (Arr[i] == 0)
        {
          break;
        }
        strLine += (char)Arr[i];
      }
      i++;
      return strLine;
    }

    static byte[] MakeByteArrayFromString(string Name)
    {
      byte[] arr = new byte[Name.Length];
      for (int i = 0; i < Name.Length; i++)
        arr[i] = (byte)Name[i];
      return arr;
    }

    static void CopyArrayTo(SByte[] Src, int SrcOffset, SByte[] Dest, int DestOffset, int Len)
    {
      while (Len > 0)
      {
        Dest[DestOffset++] = Src[SrcOffset++];
        Len--;
      }
    }

    static char cNibble(byte bVal)
    {
      if (bVal > 9)
        return (char)(bVal - 10 + 'A');
      else
        return (char)(bVal + '0');
    }

    static byte HexNibble(char Nibble)
    {
      if ((Nibble >= '0') && (Nibble <= '9'))
        return (byte)(Nibble - '0');
      else if ((Nibble >= 'A') && (Nibble <= 'F'))
        return (byte)(Nibble - 'A' + 10);
      else if ((Nibble >= 'a') && (Nibble <= 'f'))
        return (byte)(Nibble - 'a' + 10);
      else
        return 0;
    }

    static byte HexByte(char HiNibble, char LoNibble)
    {
      return (byte)(HexNibble(LoNibble) + HexNibble(HiNibble) * 16);
    }

    static string MakeHexString(byte[]Arr)
    {
      string strLine;
      strLine = "";
      for (int i = Arr.Length-1; (i >= 0) ;--i)
      {
        byte lChar = (byte)(Arr[i] & 0x0F);
        byte hChar = (byte)((Arr[i]>>4)&0x0F);

        strLine += cNibble(hChar);
        strLine += cNibble(lChar);
      }
      return strLine;
    }

    static byte[] FromHexString(string HexString,int Length)
    {
      while (HexString.Length < Length * 2)
        HexString = "0" + HexString;
      byte[] arr = new byte[HexString.Length/2];
      for (int i = 0,j = Length-1; (j >= 0) && (i < HexString.Length/2); i++,j--)
        arr[j] = HexByte(HexString[i*2],HexString[i*2+1]);
      return arr;
    }

    int PortHandle;
    bool SelectTransponder()
    {
      string ErrMsg;
      Byte[] UID_Data = new Byte[4];
      Byte[] Config = new Byte[4];

      if (TTYP == GIS_LF_API.TTYP_HITAG_1)
      {
        if (GIS_LF_API.TSLF_UID_Request(PortHandle, TTYP, UID_Data, 4) == -1)
        {
          ErrMsg = "Error " + GIS_LF_API.TSLF_GetLastError(PortHandle).ToString() + " at CCNew";
          MessageBox.Show(ErrMsg);
          return false;
        }
        
        if (GIS_LF_API.TSLF_Select(PortHandle, TTYP, UID_Data, 4, Config, 4) == -1)
        {
          ErrMsg = "Error " + GIS_LF_API.TSLF_GetLastError(PortHandle).ToString() + " at UID Select";
          MessageBox.Show(ErrMsg);
          return false;
        }
      }
      else if (TTYP == GIS_LF_API.TTYP_HITAG_2)
      {
        if (GIS_LF_API.TSLF_UID_Request(PortHandle, TTYP, UID_Data, 4) == -1)
        {
          ErrMsg = "Error " + GIS_LF_API.TSLF_GetLastError(PortHandle).ToString() + " at StartAuth";
          MessageBox.Show(ErrMsg);
          return false;
        }
        Byte[] Password = new Byte[]{ 0x52, 0x4B, 0x49, 0x4D }; // Use default password
        Byte[] TagPW = new Byte[4];
        if (GIS_LF_API.TSLF_Select(PortHandle, TTYP, Password, 4, TagPW, 4) == -1)
        {
          ErrMsg = "Error " + GIS_LF_API.TSLF_GetLastError(PortHandle).ToString() + " at Select";
          MessageBox.Show(ErrMsg);
          return false;
        }
      }
      else if (TTYP == GIS_LF_API.TTYP_HITAG_S)
      {
        if (GIS_LF_API.TSLF_UID_Request(PortHandle, TTYP, UID_Data, 4) == -1)
        {
          ErrMsg = "Error " + GIS_LF_API.TSLF_GetLastError(PortHandle).ToString() + " at UID Request";
          MessageBox.Show(ErrMsg);
          return false;
        }
        if (GIS_LF_API.TSLF_Select(PortHandle, TTYP, UID_Data, 4, Config, 4) == -1)
        {
          ErrMsg = "Error " + GIS_LF_API.TSLF_GetLastError(PortHandle).ToString() + " at UID Select";
          MessageBox.Show(ErrMsg);
          return false;
        }
      }

      // All other Transponder types do not need to be selected,
      // so we just return true to signal all is ok.
      return true;
    }

    public Form1()
    {
      InitializeComponent();

      int MaxLen = 255;
      int ListLen = 0;
      int DevListLen;

      SByte[] NamenListe = new SByte[1000];
      SByte[] DevList = new SByte[MaxLen];

      DevListLen = GIS_LF_API.TSLF_GetUSBDeviceNames(DevList, MaxLen) - 1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_LF_API.TSLF_GetLanDeviceNames(DevList, MaxLen) - 1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      DevListLen = GIS_LF_API.TSLF_GetCOMDeviceNames(DevList, MaxLen) - 1;
      CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen);
      ListLen += DevListLen;
      ListLen++;

      if (ListLen > 1)
      {
        string DeviceName;
        // Use first Device in List
        DeviceName = MakeStringFromArray(NamenListe, 0);

        PortHandle = GIS_LF_API.TSLF_Open(MakeArrayFromString(DeviceName), 19200, 0, 500);
        if (GIS_LF_API.TSLF_IsProgrammer(PortHandle) != 1)
        {
          MessageBox.Show("Device is no Programmer");
        }
      }
      else
      {
        PortHandle = 0;
      }

      if (PortHandle <= 0)
      {
        MessageBox.Show("Device could not be opened");
      }
    }

    private void Close_Click(object sender, EventArgs e)
    {
      if (PortHandle > 0)
        GIS_LF_API.TSLF_Close(PortHandle);
      Close();
    }

    private void Read_Click(object sender, EventArgs e)
    {
      if (PortHandle > 0)
      {
        Byte[] Buffer = new Byte[4];
        int iBlockNr = Convert.ToInt32(BlockNr.Text);

        if (!SelectTransponder())
          return;

        if (GIS_LF_API.TSLF_Read(PortHandle, TTYP, iBlockNr, Buffer, 4) == 4)
        {
          BlockData.Text = MakeHexString(Buffer);
        }
        else
        {
          MessageBox.Show("Read Error");
        }
      }
      else
      {
        MessageBox.Show("No Device attached");
      }
    }

    private void Write_Click(object sender, EventArgs e)
    {
      if (PortHandle > 0)
      {
        Byte[] Buffer = FromHexString(BlockData.Text,4);

        int iBlockNr = Convert.ToInt32(BlockNr.Text);

        if (!SelectTransponder())
          return;

        if (GIS_LF_API.TSLF_Write(PortHandle, TTYP, iBlockNr, Buffer, 4, 0) < 0)
        {
          MessageBox.Show("Write Error");
        }
        else
        {
          MessageBox.Show("Write OK");
        }
      }
      else
      {
        MessageBox.Show("No Device attached");
      }
    }
  }
}
