// TempTestDlg.cpp : Implementation file
//

#include "stdafx.h"
#include "TempTest.h"
#include "TempTestDlg.h"
#include "TS_LF_Import.h"

#include "label.h"
#include "BitmapStatic.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib, "version.lib")

// Set TRANSPONDER_TYPE to the type of Transponder which you want to use.
// Valid Transponder types are given in TS_RW_Import.h
// TTYP_HITAG_2   TTYP_HITAG_S   
// TTYP_Q5        TTYP_EM4569  
// TTYP_EM4305    TTYP_ATA5577

#define TRANSPONDER_TYPE TTYP_EL9265

// Set the temperature calculation mode
// TEMP_MODE 0: Read the Temperature by Reading the sensor and calibration data and then calculating C
// TEMP_MODE 1: Read the Temperature by Reading the sensor and using DLL function to calculate C from Sensor data
// TEMP_MODE 2: Read the Temperature in C directly, Conversion of Sensor data to C is done inside of DLL or device.

#define TEMP_MODE 2

CString GetProgVersion ()
{
  char * abData;
  char String[255];
  CString Version;
  DWORD  handle = NULL;
  UINT   wSize = 0;
  DWORD  dwMax = 0;
  LPSTR  lpBuffer = NULL;
  char ExeName[_MAX_PATH];
  ::GetModuleFileName(NULL,ExeName,_MAX_PATH);
  dwMax = GetFileVersionInfoSize(ExeName, &handle);
  if (dwMax == 0)
  {
    Version = "1.xx";
    return Version;
  }
  if (dwMax > 32000)
  {
    Version = "1.xx";
    return Version;
  }
  
  abData = new char[dwMax+10];
  memset (abData,0,(WORD)(dwMax+10));
  if (GetFileVersionInfo(ExeName, handle, dwMax, abData))
  {
    strcpy_s (String,"\\StringFileInfo\\040704b0\\ProductVersion");
    if (VerQueryValue(abData, String, (LPVOID *)&lpBuffer, &wSize))
    {
      if ((lpBuffer) && (wSize!=0) && (strlen(lpBuffer) < 20))
        Version = lpBuffer;
    }
  }
  if (Version.IsEmpty())
    Version = "1.xx";
  delete []abData;
  return Version;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialog box for "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CBitmapStatic	m_GisBitmap;
  CLabel m_Email;
  CLabel m_URL;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_GIS_LOGO, m_GisBitmap);
	DDX_Control(pDX, IDC_EMAIL, m_Email);
	DDX_Control(pDX, IDC_URL, m_URL);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

  // URL und Email als Link darstellen (Blau, unterstrichen)
  LOGFONT lf;
  GetFont()->GetLogFont(&lf);
  lf.lfUnderline = TRUE;
  m_Email.SetFont(&lf);
  m_Email.SetLink(TRUE);
  m_Email.SetTextColor(RGB(  0,  0,255));
  m_Email.SetLinkCursor(::LoadCursor(NULL,MAKEINTRESOURCE(32649)));
  m_URL  .SetFont(&lf);
  m_URL  .SetLink(TRUE);
  m_URL  .SetTextColor(RGB(  0,  0,255));
  m_URL  .SetLinkCursor(::LoadCursor(NULL,MAKEINTRESOURCE(32649)));

  m_GisBitmap.SetTransparent();

  // show correct version information
  CString text;
  GetDlgItemText(IDC_VERSION,text);
  
  text += " ";
  text += GetProgVersion();
  SetDlgItemText (IDC_VERSION,text);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

/////////////////////////////////////////////////////////////////////////////
// CTempTestDlg Dialogfeld

CTempTestDlg::CTempTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTempTestDlg::IDD, pParent)
  , m_strCountry(_T("")),m_BlockNr(8)
{
	//{{AFX_DATA_INIT(CTempTestDlg)
	m_strIdentNr = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
  m_nPortHandle = NULL;
  m_nError = 0;
}

void CTempTestDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);

  //{{AFX_DATA_MAP(CTempTestDlg)
  DDX_Text(pDX, IDC_ANIMAL_DATA, m_strIdentNr);
  //}}AFX_DATA_MAP
  DDX_Text(pDX, IDC_COUNTRY, m_strCountry);
  DDX_Text(pDX, IDC_BLOCKNR, m_BlockNr);
  DDV_MinMaxInt(pDX,m_BlockNr,8,57);
}

BEGIN_MESSAGE_MAP(CTempTestDlg, CDialog)
	//{{AFX_MSG_MAP(CTempTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_READ_ANIMAL, OnReadAnimal)
	ON_BN_CLICKED(IDC_WRITE_ANIMAL, OnWriteAnimal)
	//}}AFX_MSG_MAP
  ON_BN_CLICKED(IDC_SPEICHERN, &CTempTestDlg::OnSpeichern)
  ON_BN_CLICKED(IDC_MESSEN, &CTempTestDlg::OnMessen)
  ON_BN_CLICKED(IDC_RECONNECT, &CTempTestDlg::OnReconnect)
  ON_BN_CLICKED(IDC_AKTIVIEREN, &CTempTestDlg::OnAktivieren)
  ON_BN_CLICKED(IDC_DEAKTIVIEREN, &CTempTestDlg::OnDeaktivieren)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTempTestDlg Message-Handler

BOOL CTempTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// for big Symbol
	SetIcon(m_hIcon, FALSE);		// for small Symbol

  ConnectDevice();
  
  if (m_nPortHandle <= 0)
    AfxMessageBox("No connection to device");
	return TRUE;  
}

bool CTempTestDlg::ConnectDevice()
{
  // Get List of all USB Devices
  int nMaxSize = 255;
	char USBNamesBuffer[255];
  CStringList USBListe;
  CString strName;
	int nLen = TSLF_GetUSBDeviceNames(USBNamesBuffer,nMaxSize);
  int nStrLen = 0;
  do
  {
    strName = USBNamesBuffer + nStrLen;
    nStrLen += strName.GetLength() + 1;
    if(strName.GetLength() != 0)
      USBListe.AddTail(strName);
  }while(strName.GetLength() != 0);

  if (m_nPortHandle > 0)
    TSLF_Close(m_nPortHandle);

	// Use first USB device and open port
  // the port has to be closed when application closes
  // This is done in OnDestroy() .
  // If no USB-Device is found, the application tries to open a COM Port.
  m_nPortHandle = -1;
  if(USBListe.GetCount() > 0)
  {
    m_nPortHandle = TSLF_Open(USBListe.GetHead(),19200,0,1000);
    if (m_nPortHandle > 0)
    {
      // Get device version from device, to check if read device is connected.
      // The first 3 digits of the string give the device number
      // valid device number is 039 for TS-W34AC, 244 for TS-RW38AC
      char Version[4],DeviceName[32];
      int nReturn = TSLF_GetDeviceVersion(m_nPortHandle, Version, 4,DeviceName,32);
      if(nReturn == -1)
      {
        int Error = TSLF_GetLastError(m_nPortHandle);
        TSLF_Close(m_nPortHandle);
        m_nPortHandle = -1;
      }
      else
      {
        if (TSLF_IsAnimalProgrammer(m_nPortHandle) != 1)
        {
          // Invalid device, will be closed
          AfxMessageBox("Connected device is no Animal programmer!");
          int Error = TSLF_GetLastError(m_nPortHandle);
          TSLF_Close(m_nPortHandle);
          m_nPortHandle = -1;
        }
      }
    }
  }
  else
  {
    // Try connection using a COM port
    CString com = "COM1";
    int nMaxSize = 255;
    // First get list of com ports
	  char * COMNamesBuffer = new char[nMaxSize];
    CStringList COMListe;
    CString strName;
	  int nLen = TSLF_GetCOMDeviceNames(COMNamesBuffer,nMaxSize);
    int nStrLen = 0;
    do
    {
      strName = COMNamesBuffer + nStrLen;
      nStrLen += strName.GetLength() + 1;
      if(strName.GetLength() != 0)
        COMListe.AddTail(strName);
    }while(strName.GetLength() != 0);
    delete COMNamesBuffer;

    // then try all found ports
    POSITION Pos = COMListe.GetHeadPosition();
    while (Pos)
    {
      m_nPortHandle = TSLF_Open(COMListe.GetNext(Pos),19200,0,1000);
      if (m_nPortHandle > 0)
      {
        // Get device version from device, to cehck if read device is connected.
        // The first 3 digits of the string give the device number
        // valid device number is 039 for TS-W34AC, 244 for TS-RW38AC
        char Version[4],DeviceName[32];
        int nReturn = TSLF_GetDeviceVersion(m_nPortHandle, Version, 4,DeviceName,32);
        if(nReturn == -1)
        {
          int Error = TSLF_GetLastError(m_nPortHandle);
          TSLF_Close(m_nPortHandle);
          m_nPortHandle = -1;
        }
        else
        {
          if (TSLF_IsAnimalProgrammer(m_nPortHandle) != 1)
          {
            // Invalid device, will be closed
            AfxMessageBox("Connected device is no Animal Programmer!");
            int Error = TSLF_GetLastError(m_nPortHandle);
            TSLF_Close(m_nPortHandle);
            m_nPortHandle = -1;
          }
          break;
        }
      }
    }
  }
  return m_nPortHandle > 0;
}

void CTempTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CTempTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTempTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTempTestDlg::OnDestroy()
{
  // Close Port if open
  if(m_nPortHandle)
  {
    TSLF_Close(m_nPortHandle);
    m_nPortHandle = 0;
  }

	CDialog::OnDestroy();
}

BYTE MakeHex(CString str)
{
  return (BYTE)strtol(str,NULL,16);
}

void CTempTestDlg::OnReadAnimal()
{
  SetDlgItemText(IDC_MESSAGE,"");
  if (m_nPortHandle <= 0)
  {
    if (!ConnectDevice())
    {
      SetDlgItemText(IDC_MESSAGE,"No Device open");
      return;
    }
  }

  UpdateData(TRUE);
  SetDlgItemText(IDC_ANIMAL_TEMP_HEX,"");
  SetDlgItemText(IDC_ANIMAL_TEMP,"");

  __int64 IdentNr = 0;
  int Country;
  int AnimalFlag;
  int DatenblockFlag;
  int Reserved;
  int Extension;


  // During Animal read the transponder must be not selected!
  // So we do a Reset of the transponder before
  if (TSLF_ResetTransponder(m_nPortHandle, TRANSPONDER_TYPE) == -1)
  {
    CString strMsg;
    strMsg.Format("Error %d at ResetTransponder",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
  }

  if (TSLF_Read_FDXB(m_nPortHandle, &Country, (BYTE*)&IdentNr, 8, &AnimalFlag, &DatenblockFlag, &Reserved, &Extension) != -1)
  {
    // Read successfully done
    m_strIdentNr.Format("%I64d",IdentNr);
    m_strCountry.Format("%d", Country);

    if (Extension != 0)
    {
      long Temp = TSLF_ConvertTemp(m_nPortHandle, TRANSPONDER_TYPE, Extension);
      if (Temp != TSLF_RETVAL_ERROR)
      {
        CString Line;
        Line.Format("%.3f",Temp/65536.);
        SetDlgItemText(IDC_ANIMAL_TEMP,Line);
      }
    }
  }
  else
  {
    CString strMsg;
    strMsg.Format("Error %d reading Animal data",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
  }

  UpdateData(FALSE);
}

void CTempTestDlg::OnWriteAnimal()
{
  SetDlgItemText(IDC_MESSAGE,"");
  if (m_nPortHandle <= 0)
  {
    if (!ConnectDevice())
    {
      SetDlgItemText(IDC_MESSAGE,"No Device open");
      return;
    }
  }

  UpdateData(TRUE);

  // Get Animal Code from Editbox
  __int64 IdentNr = _atoi64(m_strIdentNr);
  int Country = atoi(m_strCountry);

  // Simply call Write Animal, all necessary steps are done inside.

  // Define Factory ID with 0 so it is written in any case (testing for same Factory ID as before)
  __int64 FactoryID = 0;

  // We have to give 5 as size because only lowest 5 Byte contain Animal Data.
  if (TSLF_Write_FDXB(m_nPortHandle, TRANSPONDER_TYPE, (BYTE*)&FactoryID, Country, (BYTE*)&IdentNr, 8, 1, 0, 0, 0, 0) != -1)
  {
    CString strMsg;
    strMsg.Format("Animal data written to Transponder");
    SetDlgItemText(IDC_MESSAGE,strMsg);
  }
  else
  {
    CString strMsg;
    strMsg.Format("Error %d writing Animal Data",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
    if (TSLF_GetLastError(m_nPortHandle) == TSLF_PORTHANDLE_UNGUELTIG)
      m_nPortHandle = 0;
  }

  UpdateData(FALSE);
}

void CTempTestDlg::OnMessen()
{
  SetDlgItemText(IDC_MESSAGE,"");
  if (m_nPortHandle <= 0)
  {
    if (!ConnectDevice())
    {
      SetDlgItemText(IDC_MESSAGE, "No Device open");
      return;
    }
  }

  if (!UpdateData(TRUE))
    return;
  SetDlgItemText(IDC_MESS_TEMP_HEX,"");
  SetDlgItemText(IDC_MESS_TEMP,"");

#if TEMP_MODE == 2
  // Read Temperature in C directly
  int Temp;
  if (TSLF_GetTempGrad(m_nPortHandle,TRANSPONDER_TYPE,&Temp) != TSLF_NO_ERROR)
  {
    CString strMsg;
    strMsg.Format("Error %d reading Temp",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
    if (TSLF_GetLastError(m_nPortHandle) == TSLF_PORTHANDLE_UNGUELTIG)
      m_nPortHandle = 0;
    return;
  }

  CString Line;
  Line.Format("%.3f",Temp/65536.);
  SetDlgItemText(IDC_MESS_TEMP,Line);
  return;
#else
  // Read Sensor data
  int SensorData;
  if (TSLF_GetTempSensor(m_nPortHandle,TRANSPONDER_TYPE,&SensorData) == TSLF_RETVAL_OK)
  {
    CString Line;
    Line.Format("%02X %02X %02X %02X ",
                LOBYTE(LOWORD(SensorData)), HIBYTE(LOWORD(SensorData)),
                LOBYTE(HIWORD(SensorData)), HIBYTE(HIWORD(SensorData)));
    SetDlgItemText(IDC_MESS_TEMP_HEX,Line);

#if TEMP_MODE == 1
    // Do Calculation of Temperature in DLL
    long Temp = TSLF_ConvertTemp(m_nPortHandle, TRANSPONDER_TYPE, SensorData);
    if (Temp != TSLF_RETVAL_ERROR)
    {
      Line.Format("%.3f",Temp/65536.);
      SetDlgItemText(IDC_MESS_TEMP,Line);
    }
#else
    // Read Calibration data
    BYTE Calib[8];
    if (TSLF_Read(m_nPortHandle,TRANSPONDER_TYPE, 0x3B, Calib,8) != 8)
    {
      SetDlgItemText(IDC_MESSAGE,"Read Calibration Error");
      return;
    }

    // Calculate Temperature from data
    double astrich = MAKEWORD(Calib[0], Calib[1]);
    double a = 14. + 2.*astrich/65536.;
    double Astrich = MAKEWORD(Calib[6], Calib[7]);
    double Bstrich = MAKEWORD(Calib[4], Calib[5]);
    double A = 608. + 32.*Astrich/65536.;
    double B = 270. + 16.*Bstrich/65536.;

    double X = double(HIWORD(SensorData)&0x1F) + LOWORD(SensorData)/16384.;
    double Temp = A * (a/(a+X)) - B;
    Line.Format("%.3f",Temp);
    SetDlgItemText(IDC_MESS_TEMP,Line);
#endif
  }
  else
  {
    CString strMsg;
    strMsg.Format("Error %d reading Temp",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
    if (TSLF_GetLastError(m_nPortHandle) == TSLF_PORTHANDLE_UNGUELTIG)
      m_nPortHandle = 0;
  }
#endif
}

void CTempTestDlg::OnSpeichern()
{
  SetDlgItemText(IDC_MESSAGE, "");
  if (m_nPortHandle <= 0)
  {
    if (!ConnectDevice())
    {
      SetDlgItemText(IDC_MESSAGE,"No Device open");
      return;
    }
  }

  if (!UpdateData(TRUE))
    return;
  SetDlgItemText(IDC_MESS_TEMP_HEX,"");
  SetDlgItemText(IDC_MESS_TEMP,"");

  int SensorData;
  if (TSLF_StoreTempSensor(m_nPortHandle,TRANSPONDER_TYPE,m_BlockNr, m_BlockNr, &SensorData) == TSLF_RETVAL_OK)
  {
    CString Line;
    Line.Format("%02X %02X %02X %02X ",
                LOBYTE(LOWORD(SensorData)), HIBYTE(LOWORD(SensorData)),
                LOBYTE(HIWORD(SensorData)), HIBYTE(HIWORD(SensorData)));
    SetDlgItemText(IDC_MESS_TEMP_HEX,Line);

    BYTE Calib[8];
    if (TSLF_Read(m_nPortHandle,TRANSPONDER_TYPE, 0x3B, Calib,8) != 8)
    {
      SetDlgItemText(IDC_MESSAGE,"Read Calibration Error");
      return;
    }

    double astrich = MAKEWORD(Calib[0], Calib[1]);
    double a = 14. + 2.*astrich/65536.;
    double Astrich = MAKEWORD(Calib[6], Calib[7]);
    double Bstrich = MAKEWORD(Calib[4], Calib[5]);
    double A = 608. + 32.*Astrich/65536.;
    double B = 270. + 16.*Bstrich/65536.;

    double X = double(HIWORD(SensorData)&0x1F) + LOWORD(SensorData)/16384.;
    double Temp = A * (a/(a+X)) - B;
    Line.Format("%.3f",Temp);
    SetDlgItemText(IDC_MESS_TEMP,Line);
  }
  else
  {
    CString strMsg;
    strMsg.Format("Error %d reading Temp",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
    if (TSLF_GetLastError(m_nPortHandle) == TSLF_PORTHANDLE_UNGUELTIG)
      m_nPortHandle = 0;
  }
}

void CTempTestDlg::OnReconnect()
{
  if (!ConnectDevice())
  {
    AfxMessageBox("No Device open");
    return;
  }
}

void CTempTestDlg::OnAktivieren()
{
  SetDlgItemText(IDC_MESSAGE, "");
  if (m_nPortHandle <= 0)
  {
    if (!ConnectDevice())
    {
      SetDlgItemText(IDC_MESSAGE,"No Device open");
      return;
    }
  }

  if (!UpdateData(TRUE))
    return;

  if (TSLF_ActivateTempSensor(m_nPortHandle,TRANSPONDER_TYPE,m_BlockNr) == TSLF_RETVAL_ERROR)
  {
    CString strMsg;
    strMsg.Format("Error %d activating Temp Sensor",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
    if (TSLF_GetLastError(m_nPortHandle) == TSLF_PORTHANDLE_UNGUELTIG)
      m_nPortHandle = 0;
    return;
  }
  SetDlgItemText(IDC_MESSAGE,"Temp Sensor Activated");
}

void CTempTestDlg::OnDeaktivieren()
{
  SetDlgItemText(IDC_MESSAGE, "");
  if (m_nPortHandle <= 0)
  {
    if (!ConnectDevice())
    {
      SetDlgItemText(IDC_MESSAGE,"No Device open");
      return;
    }
  }

  if (!UpdateData(TRUE))
    return;

  if (TSLF_ActivateTempSensor(m_nPortHandle,TRANSPONDER_TYPE,0) == TSLF_RETVAL_ERROR)
  {
    CString strMsg;
    strMsg.Format("Error %d deactivating Temp Sensor",TSLF_GetLastError(m_nPortHandle));
    SetDlgItemText(IDC_MESSAGE,strMsg);
    if (TSLF_GetLastError(m_nPortHandle) == TSLF_PORTHANDLE_UNGUELTIG)
      m_nPortHandle = 0;
    return;
  }
  SetDlgItemText(IDC_MESSAGE,"Temp Sensor Deactivated");
}
