Attribute VB_Name = "TSLF"
Option Explicit

'Fehlerliste  Dll Funktionsaufrufe
Global Const TSLF_NO_ERROR = 0
Global Const TSLF_PORT_OEFFNEN = 1
Global Const TSLF_TIMEOUT_UNGUELTIG = 5
Global Const TSLF_PORTHANDLE_UNGUELTIG = 6
Global Const TSLF_TIMEOUT = 7
Global Const TSLF_BUFFER_ZU_KLEIN = 8
Global Const TSLF_BUFFERGROESSE_FALSCH = 9
Global Const TSLF_FALSCHER_TRANSPONDERTYP = 10
Global Const TSLF_KEINE_SENDEDATEN = 11
Global Const TSLF_BLOCKNUMMER_UNGUELTIG = 12
Global Const TSLF_LOCK_UNGUELTIG = 13
Global Const TSLF_CHECKSUMMENFEHLER = 14
Global Const TSLF_KEINE_KOMMUNIKATION = 15
Global Const TSLF_CHECKBUFFER_LEER = 16
Global Const TSLF_NULL_POINTER = 17
Global Const TSLF_MODE_UNGUELTIG = 18
Global Const TSLF_DONT_SET_USB = 19
Global Const TSLF_COMPARE_ERROR = 20
Global Const TSLF_NACK = 21
Global Const TSLF_SYNC = 22
Global Const TSLF_LOCKED = 23
Global Const TSLF_CANCEL = 24
Global Const TSLF_INVALID_DATA = 25

Global Const TTYP_DEFAULT = 0
Global Const TTYP_HITAG_2 = 2
Global Const TTYP_Q5 = 3
Global Const TTYP_HITAG_S = 4
Global Const TTYP_HITAG_1 = 5
Global Const TTYP_TITAN = 6
Global Const TTYP_4569 = 7
Global Const TTYP_EM4305 = 8
Global Const TTYP_ATA5577 = 9
Global Const TTYP_HITAG_Y = 10
Global Const TTYP_ATA5575 = 11
Global Const TTYP_SIC7888 = 12
Global Const TTYP_ATA5551 = 13
Global Const TTYP_EL9265  = 14
Global Const TTYP_EM4582  = 15
  
Global Const TTYP_HDX_TIRIS = 33
Global Const TTYP_HDX_INCIDE = 34
Global Const TTYP_HDX_PLUS = 35
Global Const TTYP_HDX_SIC7900 = 36
Global Const TTYP_HDX_PLUS_HIQ = 37
Global Const TTYP_HDX_SIC7999 = 38

Global Const TTYP_ATA5577_PW = &H30
Global Const TTYP_EX_BLOCKFOLGE = &H80

Global Const TTYP_FIRST = 1
Global Const TTYP_LAST = &H26

Global Const SIC_LOGIN_RW = &H0100

Global Const READ_AFTER_WRITE = &H0100
Global Const READ_AFTER_WRITE_INVERS = &H0200
Global Const READ_INVERS = &H0400
Global Const DO_ALL_ERRORS = &H0800
Global Const NO_RETRY = &H1000
Global Const DO_OVERLAPPED = &H2000
Global Const NO_READ_AFTER_WRITE = &H4000
Global Const NO_FACTORY_ID = &H8000

Global Const ANSWER_MODE_MANCHESTER2KBIT = &H0  ' Manchester     RF/64
Global Const ANSWER_MODE_BIPHASE4KBIT = &H1     ' Diff. Biphase  RF/32
Global Const ANSWER_MODE_FSK2A = &H2            ' FSK 2A         RF/50
Global Const ANSWER_MODE_HDX = &H3              ' HDX
Global Const ANSWER_MODE_FSK_MANCHESTER = &H4   ' FSK 2A         RF/50 + Manchester Dekodierung
Global Const ANSWER_MODE_MANCHESTER4KBIT = &H5  ' Manchester     RF/32
Global Const ANSWER_MODE_BIPHASE2KBIT = &H6     ' Diff. Biphase  RF/64
Global Const ANSWER_MODE_FSK2A2KBIT = &H7       ' FSK 2A         RF/64

Global Const ANSWER_MODE_INVERS = &H80          ' Additional invers Flag

  'Parameter fr TSLF_ReadFormattedData()
Global Const TSLF_FORMAT_UNIQUE = &H1
Global Const TSLF_FORMAT_GIS16BIT = &H2
Global Const TSLF_FORMAT_UNIQUEXL = &H3
Global Const TSLF_FORMAT_ANIMAL_FDXB = &H4
Global Const TSLF_FORMAT_ANIMAL_FDXA = &H5
Global Const TSLF_FORMAT_ANIMAL_HDX = &H6

Global Const TSLF_READ_BY_DEFAULT = &H0
Global Const TSLF_READ_BY_CMD = &H100
Global Const TSLF_READ_UID = &H200

'possible values for Lock in WriteFSK commands
Global Const TSLF_WRITEFSK_LOCK_NONE = 0
Global Const TSLF_WRITEFSK_LOCK_DATA = 1
Global Const TSLF_WRITEFSK_LOCK_CONFIG = 2
Global Const TSLF_WRITEFSK_LOCK_ALL = 3

'Rckgabewerte
Global Const TSLF_RETVAL_ERROR = -1
Global Const TSLF_RETVAL_OK = 0
Global Const TSLF_RETVAL_FORMAT_FALSCH = 1
Global Const TSLF_RETVAL_LOCKED = 2
Global Const TSLF_RETVAL_SAME_TAG = 3
Global Const TSLF_RETVAL_PROCESS_PENDING = 4
Global Const TSLF_RETVAL_INVALID_DATA = 5

'// Get Library Version
Public Declare Function TSLF_LibVersion Lib "TS_LF_SDK.DLL" () As Long
  Public Declare Function TSLF_SetLog Lib "TS_LF_SDK.DLL" (ByRef LogFileName As SByte) As Long

Public Declare Function TSLF_IsVirtualComInstalled Lib "TS_LF_SDK.DLL" () As Long

Public Declare Function TSLF_IsDeviceDriverMissing Lib "TS_LF_SDK.DLL" () As Long
  
'// Get Names of all USB Devices connected, only valid devices are listed
Public Declare Function TSLF_GetUSBDeviceNames Lib "TS_LF_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all USB Devices connected, all devices from GiS are listed
Public Declare Function TSLF_GetUSBDeviceNamesEx Lib "TS_LF_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all COM Ports available, not tested if there is a device at the port connected.
Public Declare Function TSLF_GetCOMDeviceNames Lib "TS_LF_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all valid LAN devices found in same subnet
Public Declare Function TSLF_GetLanDeviceNames Lib "TS_LF_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Get Names of all LAN devices found even in other subnets
Public Declare Function TSLF_GetLanDeviceNamesEx Lib "TS_LF_SDK.DLL" (Buffer As Any, ByVal nBufferSize As Long) As Long

'// Change IP Address of LAN device
Public Declare Function TSLF_ChangeLanIPAddress Lib "TS_LF_SDK.DLL" (OldAddress As Any, NewAddress As Any, IPMask As Any) As Long

'// Change IP Address and Gateway of LAN device
Public Declare Function TSLF_ChangeLanIPAddressEx Lib "TS_LF_SDK.DLL" (OldAddress As Any, NewAddress As Any, IPMask As Any, GatewayAddress As Any) As Long

'// Get IP Address and Gateway of LAN device
Public Declare Function TSLF_GetLanIPAddressEx Lib "TS_LF_SDK.DLL" (strName As Any, Address As Any, IPMask As Any, GatewayAddress As Any) As Long

'// Get Information about LAN Device
Public Declare Function TSLF_GetLanInfo Lib "TS_LF_SDK.DLL" (strName As Any, DHCPName As Any, IPAddress As Any, IPMask As Any, GatewayAddress As Any) As Long

'// Get Remote Server IP for LAN device in Client Mode
Public Declare Function TSLF_LanGetRemoteIPAndPort Lib "TS_LF_SDK.DLL" (strName As Any, pIPAddress As Any, ByVal MaxIPLen As Long, ByRef pPortNr As Long) As Long

'// Set Remote Server IP for LAN device in Client Mode
Public Declare Function TSLF_LanWriteRemoteIPAndPort Lib "TS_LF_SDK.DLL" (strName As Any, pIPAddress As Any, ByVal PortNr As Long) As Long

'// Check if specific LAN device is available
Public Declare Function TSLF_IsLanDeviceAvailable Lib "TS_LF_SDK.DLL" (Address As Any) As Long

'// Open LAN Device for configuration
Public Declare Function TSLF_LanConfigOpen Lib "TS_LF_SDK.DLL" (strName As Any) As Long

'// Set Configuration Record of LAN device, use with care!
Public Declare Function TSLF_LanConfigGet Lib "TS_LF_SDK.DLL" (ByVal nHandle As Long, ByVal RecordNr As Long, pData As Any, ByVal DatLen As Long) As Long

'// Get Configuration Record of LAN device
Public Declare Function TSLF_LanConfigSet Lib "TS_LF_SDK.DLL" (ByVal nHandle As Long, ByVal RecordNr As Long, pData As Any, ByVal DatLen As Long) As Long

'// Close LAN device configuration.
Public Declare Function TSLF_LanConfigClose Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal Reset As Long) As Long

'// Read Configuration of USB HID device
Public Declare Function TSLF_HIDConfigRead Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pSendBuf As Any, ByVal SendBufLen As Long, pRecvBuf As Any, ByVal RecvBufLen As Long) As Long
'// Write Configuration to USB HID device
Public Declare Function TSLF_HIDConfigWrite Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pSendBuf As Any, ByVal SendBufLen As Long) As Long

Public Declare Function TSLF_Open Lib "TS_LF_SDK.DLL" (Name As Any, ByVal Baudrate As Long, ByVal ParityMode As Long, ByVal Timeout As Long) As Long
Public Declare Function TSLF_Close Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long
Public Declare Function TSLF_SetTimeout Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal Timeout As Long) As Long
Public Declare Function TSLF_GetPortName Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByRef pName As Any, ByVal MaxLen As Long) As Long

Public Declare Function TSLF_KeepAppActive Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal bActive As Long) As Long
Public Declare Function TSLF_SetReaderAdresse Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal Adresse As Long) As Long

Public Delegate Function ProgressCallback(ByVal time As ULong) As Long
Public Declare Function TSLF_SetProgressFct Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pProgress As ProgressCallback) As Long

Public Delegate Function AutoReadCallback (Arr As Any, ByVal Len As Long) As Long
Public Declare Function TSLF_StartAutoRead Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TermChar As Long, pAutoReadProc As AutoReadCallback) As Long
Public Declare Function TSLF_StopAutoRead Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long

Public Declare Function TSLF_GetDeviceVersion Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pDevVer As Any, ByVal VerLen As Long, pDevName As Any, ByVal NameLen As Long) As Long
Public Declare Function TSLF_GetDeviceNumber Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_IsProgrammer Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_IsHDXProgrammer Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_IsAnimalProgrammer Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_IsPlusProgrammer Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_IsReader Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long

Public Declare Function TSLF_IsUSB Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_GetFilter Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, pParam As Any, ByVal nParamLen As Long) As Long
Public Declare Function TSLF_SetFilter Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, pParam As Any, ByVal nParamLen As Long) As Long
Public Declare Function TSLF_SetBaudrate Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal Baudrate As Long, ByVal ParityMode As Long) As Long
Public Declare Function TSLF_SetWriteDelay Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal delay As Long) As Long
Public Declare Function TSLF_SetReaderMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal Mode As Long) As Long
Public Declare Function TSLF_GetPowerUpMode Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_SetPowerUpMode Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal mode As Long) As Long
Public Declare Function TSLF_SetRF Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal OnOff As Long) As Long
Public Declare Function TSLF_GetLastError Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long
Public Declare Function TSLF_SetIO Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal Maske As Long, ByVal Daten As Long) As Long
Public Declare Function TSLF_ReadIO Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pDaten As Long) As Long
Public Declare Function TSLF_TestIO Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Testwert As Long) As Long

Public Declare Function TSLF_SetLED Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal red As Long, ByVal green As Long, ByVal yellow As Long) As Long
Public Declare Function TSLF_Beep Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long

Public Declare Function TSLF_ClearLCD Lib "TS_LF_SDK.DLL" (ByVal handle As Long) As Long
Public Declare Function TSLF_SetLCDFont Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal FontNr As Long) As Long
Public Declare Function TSLF_SetLCDText Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal StartLine As Long,  strText As Any) As Long
Public Declare Function TSLF_SetLCDLight Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal Helligkeit As Long) As Long

Public Declare Function TSLF_ReadSerialNumber Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pSerial As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_SetConfig Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pConfig As Any, ByVal ConfigLen As Long) As Long
Public Declare Function TSLF_GetConfig Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pConfig As Any, ByVal ConfigLen As Long) As Long
Public Declare Function TSLF_SetDefault Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long
Public Declare Function TSLF_SetAnswerMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal AnswerMode As Long) As Long
Public Declare Function TSLF_GetAnswerMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long

Public Declare Function TSLF_ReadMagnetCard Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ClearMagnetCard Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long

Public Declare Function TSLF_GetActivationContext Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pData As Any, ByVal Len As Long) As Long
Public Declare Function TSLF_WriteActivationContext Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pData As Any, ByVAl Len As Long)As Long
Public Declare Function TSLF_ReadCounter Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pCounter As Long) As Long
Public Declare Function TSLF_DecrementCounter Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pNewCounter As Long) As Long
Public Declare Function TSLF_GetDaysRemain Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pDaysRemain As Long) As Long
Public Declare Function TSLF_UpdateDaysRemain Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pDaysRemain As Long) As Long

Public Declare Function TSLF_SetCommunicationMode Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal Mode As Long) As Long
Public Declare Function TSLF_RawWrite Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_RawRead Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Transfer Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal Cmd As Long, pSendBuf As Any, ByVal SendBufLen As Long, pRecvBuf As Any, ByVal RecvBufLen As Long) As Long
Public Declare Function TSLF_TransferEx Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal Cmd As Long, pSendBuf As Any, ByVal SendBufLen As Long, pRecvBuf As Any, ByVal RecvBufLen As Long, ByVal Timeout As Long) As Long

Public Declare Function TSLF_Read Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, ByVal BlockNr As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Write Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, ByVal BlockNr As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_GetTagType Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTypExpected As Long) As Long
Public Declare Function TSLF_GetTagAnswerMode Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal AnswerModeExpected As Long) As Long

Public Declare Function TSLF_Write_Unique Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FastUnique Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_UniqueXL Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_GiS16Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_GiS12Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_GiS72Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_Write_FSK26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FSK33Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FSK34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_NC34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FSK35Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FSK36Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal FixedField As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FSK37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_FSK37BitHuge Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, pCode As Any, ByVal CodeLen As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_IDCard37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CardNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_IdentiCard37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal FixedField As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_Simplex36Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal FixedField As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_AWID26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_AWID40Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CustomerNr As Long, ByVal bLock As Long) As Long
Public Declare Function TSLF_Write_Kantech39Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal FacilityCode As Long, ByVal CardNr As Long, ByVal Version As Long, ByVal Lock As Long) As Long

Public Declare Function TSLF_Read_TTFData Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal AnswerMode As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Read_Unique Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Read_FastUnique Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Read_UniqueXL Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Read_GiS16Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Read_GiS12Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Read_GiS72Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long

Public Declare Function TSLF_Read_FSK26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_FSK33Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_FSK34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_NC34Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_FSK35Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_FSK36Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long, pFixedField As Long) As Long
Public Declare Function TSLF_Read_FSK37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_FSK37BitHuge Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pCode As Any, ByVal CodeLen As Long) As Long
Public Declare Function TSLF_Read_IDCard37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_IdentiCard37Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long, pFixedField As Long) As Long
Public Declare Function TSLF_Read_Simplex36Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long, pFixedField As Long) As Long
Public Declare Function TSLF_Read_AWID26Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_AWID40Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCustomerNr As Long) As Long
Public Declare Function TSLF_Read_Kantech39Bit Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pFacilityCode As Long, pCardNr As Long, pVersion As Long) As Long

Public Declare Function TSLF_ReadFormattedData Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal ReadType As Long, Buffer As Any, ByVal BufLen As Long) As Long

Public Declare Function TSLF_ResetTransponder Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long) As Long

Public Declare Function TSLF_UID_Request Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, UID As Any, ByVal UIDLen As Long) As Long
Public Declare Function TSLF_UID_RequestAC Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, UID As Any, ByVal UIDLen As Long) As Long
Public Declare Function TSLF_UID_RequestNext Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, UID As Any, ByVal UIDLen As Long) As Long
Public Declare Function TSLF_Select Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, UID As Any, ByVal UIDLen As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Authenticate Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pKey As Any, BYVal KeyLen As Long, pBuffer As Any, ByVal BufLen As Long) As Long

Public Declare Function TSLF_WakeUp Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pPasswort As Any, ByVal PasswortLen As Long) As Long
Public Declare Function TSLF_WakeUpAndRead Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pPasswort As Byte, ByVal PasswortLen As Long, Buffer As Any, ByVal BufLen As Long) As Long

Public Declare Function TSLF_Login Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pPW As Any, ByVal nPWLen As Long) As Long
Public Declare Function TSLF_WritePW Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pOldPW As Any, ByVal OldPWLen As Long, pNewPW As Any, ByVal NewPWLen As Long) As Long

Public Declare Function TSLF_Disable Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long) As Long
Public Declare Function TSLF_Lock Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TransponderTyp As Long, ByVal BlockNr As Long) As Long

Public Declare Function TSLF_GetTagInfo Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pSysInfo As Any, ByVal SysInfoLen As Long) As Long
Public Declare Function TSLF_GetTagConfig Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByRef pConfig As Long) As Long
Public Declare Function TSLF_SetTagConfig Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal Config As Long) As Long

Public Declare Function TSLF_SetCTune Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal CTuneVal As Long, ByVal bUseValue As Long, ByVal bOne As Long, ByVal bLock As Long, ByRef pFrequenz As Long) As Long
Public Declare Function TSLF_AutoTune Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByRef pFrequenz0 As Long, ByRef pFrequenz1 As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_GetTempSensor Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long,  ByRef pSensorData As Long) As Long
Public Declare Function TSLF_StoreTempSensor Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal  TimingInfo As Long, ByVal Page As Long, ByRef pSensorData As Long) As Long
Public Declare Function TSLF_GetTempGrad Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long,  ByRef pTemp As Long) As Long
Public Declare Function TSLF_ConvertTemp Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal SensorData As Long) As Long
Public Declare Function TSLF_ActivateTempSensor Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, ByVal BlockNr As Long) As Long

Public Declare Function TSLF_WriteParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ReadParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WritePrefix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ReadPrefix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WriteSuffix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ReadSuffix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WriteTermix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ReadTermix Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WritePostcode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ReadPostcode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WriteReadModeParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_ReadReadModeParam Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WriteHitag2Key Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_WriteTagKey Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, Buffer As Any, ByVal BufLen As Long) As Long

'// Functions for ISO11784 (Animal code)
Public Declare Function TSLF_Read_FDXA Lib "TS_LF_SDK.DLL" (ByVal handle As Long, Buffer As Any, ByVal BufLen As Long) As Long
Public Declare Function TSLF_Write_FDXA Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, pFactoryID As Any, pIDNummer As Any, ByVal IdLen As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_Read_FDXB Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pCountryCode As Long, Buffer As Any, ByVal BufLen As Long, pAnimalFlag As Long, pDatenblockFlag As Long, pReserved As Long, pExtension As Long) As Long
Public Declare Function TSLF_Write_FDXB Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, pFactoryID As Any, ByVal CountryCode As Long, pIDNummer As Any, ByVal IDNummerLen As Long, ByVal AnimalFlag As Long, ByVal DatenblockFlag As Long, ByVal Reserved As Long, ByVal Extension As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_Read_HDX Lib "TS_LF_SDK.DLL" (ByVal handle As Long, pCountryCode As Long, Buffer As Any, ByVal BufLen As Long, pAnimalFlag As Long, pDatenblockFlag As Long, pReserved As Long, pExtension As Long) As Long
Public Declare Function TSLF_Write_HDX Lib "TS_LF_SDK.DLL" (ByVal handle As Long, ByVal TTyp As Long, pFactoryID As Any, ByVal CountryCode As Long, pIDNummer As Any, ByVal IDNummerLen As Long, ByVal AnimalFlag As Long, ByVal DatenblockFlag As Long, ByVal Reserved As Long, ByVal Extension As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_Read_EN14803 Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pManufacturer As Long, pSerialNumber As Long) As Long
Public Declare Function TSLF_Read_EN14803HDX Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pManufacturer As Long, pSerialNumber As Long) As Long
Public Declare Function TSLF_Write_EN14803 Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal TTyp As Long, pFactoryID As Any, ByVal Manufacturer As Long, ByVal SerialNumber As Long, ByVal bLock As Long) As Long

Public Declare Function TSLF_IsWriteFinished Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, pFactoryID As Any) As Long

'// Functions specific to EM4582 Transponder
Public Declare Function TSLF_EM4582_GetRN Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pRN As Any) As Long
Public Declare Function TSLF_EM4582_GetIncrement Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pData As Long, ByRef pVal As Long) As Long
Public Declare Function TSLF_EM4582_Increment Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pPwd As Any, ByVal PWLen As Long, ByVal Data As Long, ByVal Val As Long) As Long
Public Declare Function TSLF_EM4582_SendAccess Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pID As Any, ByVal IDLen As Long, ByRef pPwd As Any, ByVal PWLen As Long) As Long
Public Declare Function TSLF_EM4582_UnlockKey  Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pID As Any, ByVal IDLen As Long, ByRef pPwd As Any, ByVal PWLen As Long) As Long
Public Declare Function TSLF_EM4582_SingleAuth Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pRN As Any, ByVal RNLen As Long, ByRef pTokenR As Any, ByVal TokenRLen As Long, ByRef pTokenT As Any, ByVal MaxTokenTLen As Long) As Long
Public Declare Function TSLF_EM4582_MutualAuth Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pRN As Any, ByVal RNLen As Long, ByRef pTokenR As Any, ByVal TokenRLen As Long, ByRef pTokenT As Any, ByVal MaxTokenTLen As Long) As Long
Public Declare Function TSLF_EM4582_IsoMutualAuth Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pTokenR As Any, int TokenRLen, ByRef pTokenT As Any, ByVal MaxTokenTLen As Long) As Long
Public Declare Function TSLF_EM4582_SingleAuthDirect    Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal RnTokenTyp As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long
Public Declare Function TSLF_EM4582_MutualAuthDirect    Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal RnTokenTyp As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long
Public Declare Function TSLF_EM4582_IsoMutualAuthDirect Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal RnTokenTyp As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long
Public Declare Function TSLF_EM4582_SetSKA Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long
Public Declare Function TSLF_EM4582_SetSKI Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long
Public Declare Function TSLF_EM4582_SetET  Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long
Public Declare Function TSLF_EM4582_SetER  Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByRef pKey As Any, ByVal KeyLen As Long) As Long

'// Functions only for Data concentrator!
Public Declare Function TSLF_GetFaecherState Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal KonzentratorNr As Long, ByRef pFaecherState As Byte, ByVal MaxFaecher As Long) As Long
Public Declare Function TSLF_GetFachState Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal KonzentratorNr As Long, ByVal FachNr As Long, ByRev pFachState As Byte, ByRef pTransponderID As Byte, ByVal TransponderIDLength As Long) As Long
Public Declare Function TSLF_SetFachState Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal KonzentratorNr As Long, ByVal FachNr As Long, ByVal Steuerinfo As Long, ByVal Dauer As Long) As Long
Public Declare Function TSLF_GetFaecherAnzahl Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal KonzentratorNr As Long) As Long

'// Functions for Data concentrator and Multiplexer!
Public Declare Function TSLF_SetDirectDataMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, int MasterNr As Long, int FachNr As Long) As Long
Public Declare Function TSLF_LeaveDirectDataMode Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long,int OldAdresse As Long) As Long
Public Declare Function TSLF_GetAntennaCount Lib "TS_LF_SDK.DLL" (ByVal PortHandle As LongAs Long

Public Declare Function TSLF_SetAntennaPowerPreset Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long, ByVal Power As Long) As Long
Public Declare Function TSLF_GetAntennaPowerPreset Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long
Public Declare Function TSLF_GetAntennaPower Lib "TS_LF_SDK.DLL" (ByVal PortHandle As Long) As Long
