﻿

Public Class Form1

  Public Const TTYP = TTYP_HITAG_S

  Function MakeString(NamenListe() As Byte,StringNummer As Integer) As String
    MakeString = ""
    Dim i As Integer
    Dim StringFound As Boolean

    Dim aktStringNummer As Integer
    i = 0
    aktStringNummer = 0
    While (aktStringNummer <= StringNummer)
      MakeString = ""
      StringFound = False

      While (i < NamenListe.Length) And StringFound = False
        If (NamenListe(i) <> 0) Then
          MakeString = MakeString & Chr(NamenListe(i))
        Else
          StringFound = True
        End If
        i = i + 1
      End While
      If (MakeString.Length = 0)
        aktStringNummer = StringNummer+1
      End If
      aktStringNummer = aktStringNummer + 1
    End While
  End Function

  Function MakeArray(Name As String) As Byte()
    Dim i As Integer
    i = 0
    Dim NewArray(Name.Length-1) As Byte
    While i < Name.Length
      NewArray.SetValue(Convert.ToByte(Name(i)),i)
      i = i + 1
    End While
    MakeArray = NewArray
  End Function

  Sub CopyArrayTo(Src() As Byte, ByVal SrcOffset As Integer, Dest() As Byte, ByVal DestOffset As Integer, ByVal Len As Integer)
    While Len > 0
      Dest(DestOffset) = Src(SrcOffset)
      DestOffset = DestOffset + 1
      SrcOffset = SrcOffset + 1
      Len = Len - 1
    End While
  End Sub

    Function cNibble(bVal As Byte) As char
      if (bVal > 9)
        cNibble = ChrW(bVal - 10 + &H41)
      else
        cNibble = ChrW(bVal + &H30)
      end if
    End Function



    Function HexNibble(Nibble As char) As byte
      if ((Nibble >= "0") And (Nibble <= "9"))
        HexNibble = AscW(Nibble) - AscW("0")
      else if ((Nibble >= "A") And (Nibble <= "F"))
        HexNibble = AscW(Nibble) - AscW("A") + 10
      else if ((Nibble >= "a") And (Nibble <= "f"))
        HexNibble = AscW(Nibble) - AscW("a") + 10
      else
        HexNibble = 0
      end if 
    End Function


    Function HexByte(HiNibble As char, LoNibble As Char) as byte
      HexByte = HexNibble(LoNibble) + HexNibble(HiNibble) * 16
    End Function

    Function MakeHexString(Arr() As Byte) As String
      Dim strLine As String
      Dim lChar As byte
      Dim hChar As byte
      strLine = ""
      Dim i As Integer
      i = Arr.Length-1

      while (i >= 0)
        lChar = Arr(i) Mod 16
        hChar = ((Arr(i)-lChar)/16) Mod 16

        strLine = strLine + cNibble(hChar)
        strLine = strLine + cNibble(lChar)
        i = i - 1
      end While
     
      MakeHexString = strLine
    End Function

    Sub FromHexString(HexString As String , Arr() As Byte)
      while (HexString.Length < Arr.Length * 2)
        HexString = "0" + HexString
      End While
      Dim i As Integer
      Dim j As Integer
      i = 0
      j = Arr.Length - 1
      While ((j >= 0) And (i < HexString.Length/2))
        Arr(j) = HexByte(HexString(i*2),HexString(i*2+1))
        j = j - 1
        i = i + 1
      End While 
    End Sub

  Dim PortHandle As Integer
  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    Dim MaxLen As Integer
    Dim ListLen As Integer
    Dim DevListLen As Integer
    MaxLen = 255
    ListLen = 0
    DevListLen = 0

    Dim DevList(255) As Byte
    Dim NamenListe(1000) As Byte

    DevListLen = TSLF_GetUSBDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSLF_GetLanDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSLF_GetCOMDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    ListLen = ListLen + 1

    If (ListLen > 1) Then
      Dim DeviceNameArr(255) As Byte
      Dim DeviceName As String
      DeviceName = MakeString(NamenListe, 0)
      DeviceNameArr = MakeArray(DeviceName)

      PortHandle = TSLF_Open(DeviceNameArr(0), 19200, 0, 500)
      If (PortHandle > 0) Then
        If (TSLF_IsProgrammer(PortHandle) <> 1) Then
          MessageBox.Show("Device is no Programmer")
        End If
      Else
        PortHandle = 0
      End If

      If (PortHandle <= 0)
        MessageBox.Show("Device could not be opened")
      End If
    End If
  End Sub

  Private Sub Read_Click(sender As Object, e As EventArgs) Handles ReadBtn.Click
      If (PortHandle > 0) Then
        Dim Buffer(5-1) As Byte

        If (TSLF_Read_Unique(PortHandle, Buffer(0), 5) = 5) Then
          textBox1.Text = MakeHexString(Buffer)
        Else
          MessageBox.Show("Read Error")
        End If
      Else
        MessageBox.Show("No Device attached")
      End If
  End Sub

  Private Sub Write_Click(sender As Object, e As EventArgs) Handles WriteBtn.Click
      if (PortHandle > 0) then
        Dim Buffer(5-1) As Byte
        FromHexString(textBox1.Text,Buffer)

        if (TSLF_Write_Unique(PortHandle, TTYP, Buffer(0), 5, 0) < 0)
          MessageBox.Show("Write Error")
        else
          MessageBox.Show("Write OK")
        End If
        ' Reset the Antenna Field so Transponder is deselected to make next Read work again
        TSLF_ResetTransponder(PortHandle, 0)
      else
        MessageBox.Show("No Device attached")
      End If 
  End Sub

  Private Sub Close_Click(sender As Object, e As EventArgs) Handles CloseBtn.Click
    If (PortHandle > 0)
      TSLF_Close(PortHandle)
    End If
    Close()
  End Sub

End Class
