﻿

Public Class Form1

  Public Const TTYP = TTYP_HITAG_S

  Function MakeString(NamenListe() As Byte,StringNummer As Integer) As String
    MakeString = ""
    Dim i As Integer
    Dim StringFound As Boolean

    Dim aktStringNummer As Integer
    i = 0
    aktStringNummer = 0
    While (aktStringNummer <= StringNummer)
      MakeString = ""
      StringFound = False

      While (i < NamenListe.Length) And StringFound = False
        If (NamenListe(i) <> 0) Then
          MakeString = MakeString & Chr(NamenListe(i))
        Else
          StringFound = True
        End If
        i = i + 1
      End While
      If (MakeString.Length = 0)
        aktStringNummer = StringNummer+1
      End If
      aktStringNummer = aktStringNummer + 1
    End While
  End Function

  Function MakeArray(Name As String) As Byte()
    Dim i As Integer
    i = 0
    Dim NewArray(Name.Length-1) As Byte
    While i < Name.Length
      NewArray.SetValue(Convert.ToByte(Name(i)),i)
      i = i + 1
    End While
    MakeArray = NewArray
  End Function

  Sub CopyArrayTo(Src() As Byte, ByVal SrcOffset As Integer, Dest() As Byte, ByVal DestOffset As Integer, ByVal Len As Integer)
    While Len > 0
      Dest(DestOffset) = Src(SrcOffset)
      DestOffset = DestOffset + 1
      SrcOffset = SrcOffset + 1
      Len = Len - 1
    End While
  End Sub

  Dim PortHandle As Integer

  Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
    Dim MaxLen As Integer
    Dim ListLen As Integer
    Dim DevListLen As Integer
    MaxLen = 255
    ListLen = 0
    DevListLen = 0

    Dim DevList(255) As Byte
    Dim NamenListe(1000) As Byte

    DevListLen = TSLF_GetUSBDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSLF_GetLanDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSLF_GetCOMDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    ListLen = ListLen + 1

    If (ListLen > 1) Then
      Dim DeviceNameArr(255) As Byte
      Dim DeviceName As String
      DeviceName = MakeString(NamenListe, 0)
      DeviceNameArr = MakeArray(DeviceName)

      PortHandle = TSLF_Open(DeviceNameArr(0), 19200, 0, 500)
      If (PortHandle > 0) Then
        If (TSLF_IsProgrammer(PortHandle) <> 1) Then
          MessageBox.Show("Device is no Programmer")
        Else
          ' Get device version from device, to cehck if read device is connected.
          ' The first 3 digits of the string give the device number
          ' valid device number is 039 for TS-W34AC, 244 for TS-RW38AC
          Dim Version(4-1) as Byte
          Dim InternalDeviceName(32-1) as Byte
          Dim nReturn As Integer
          nReturn = TSLF_GetDeviceVersion(PortHandle, Version(0), 4,InternalDeviceName(0),32)
          if(nReturn = -1) Then
            MessageBox.Show("DeviceVersion can not be read")
            TSLF_Close(PortHandle)
            PortHandle = 0
          else
            if (TSLF_IsPlusProgrammer(PortHandle) <> 1) then
              ' Invalid device, will be closed
              MessageBox.Show("Connected device is no Waste Programmer!")
              TSLF_Close(PortHandle)
              PortHandle = 0
            End If
          End If

        End If
      Else
        PortHandle = 0
      End If

      If (PortHandle <= 0)
        MessageBox.Show("Device could not be opened")
      End If
    End If
  End Sub

  Private Sub Read_Click(sender As Object, e As EventArgs) Handles ReadBtn.Click
      If (PortHandle > 0) Then
        Dim Manufacturer As Int32
        Dim iIdentNr As Int32

        if (TSLF_Read_EN14803(PortHandle, Manufacturer, iIdentNr) >= 0) Then
          ManufacturerCode.Text = Manufacturer.ToString()
          IdentNr.Text = iIdentNr.ToString()
        Else
          MessageBox.Show("Read Error")
        End If
      Else
        MessageBox.Show("No Device attached")
      End If
  End Sub

  Private Sub Write_Click(sender As Object, e As EventArgs) Handles WriteBtn.Click
      if (PortHandle > 0) then
        Dim FactoryID(8-1) As Byte

        Dim iIdentNr As Integer
        If (IdentNr.Text.Length > 0)
          iIdentNr = Convert.ToInt32(IdentNr.Text)
        Else
          iIdentNr = 0
        End If

        Dim iManufacturer As Integer
        If (ManufacturerCode.Text.Length > 0)
          iManufacturer = Convert.ToInt32(ManufacturerCode.Text)
        Else
          iManufacturer = 0
        End If

        FactoryID(0) = 0
        FactoryID(1) = 0
        FactoryID(2) = 0
        FactoryID(3) = 0
        FactoryID(4) = 0
        FactoryID(5) = 0
        FactoryID(6) = 0
        FactoryID(7) = 0

        if (TSLF_Write_EN14803(PortHandle, TTYP, FactoryID(0), iManufacturer, iIdentNr,  0) < 0) 
          MessageBox.Show("Write Error")
        else
          MessageBox.Show("Write OK")
        End If
        ' Reset the Antenna Field so Transponder is deselected to make next Read work again
        TSLF_ResetTransponder(PortHandle, 0)
      else
        MessageBox.Show("No Device attached")
      End If 
  End Sub

  Private Sub Close_Click(sender As Object, e As EventArgs) Handles CloseBtn.Click
    If (PortHandle > 0)
      TSLF_Close(PortHandle)
    End If
    Close()
  End Sub

End Class
